---
title: BluetoothCharacteristicProperties
slug: Web/API/BluetoothCharacteristicProperties
tags:
  - API
  - Bluetooth
  - BluetoothCharacteristicProperties
  - Experimental
  - Interface
  - Reference
  - Web Bluetooth API
---
<p>{{APIRef("Bluetooth API")}}{{Draft}}{{securecontext_header}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The <strong><code>BluetoothCharacteristicProperties</code></strong> interface of the <a href="/Web/API/Web_Bluetooth_API">Web Bluetooth API</a> provides the operations that are valid on the given {{domxref('BluetoothRemoteGATTCharacteristic')}}.</span> This interface is returned by calling {{DOMxRef("BluetoothRemoteGATTCharacteristic.properties")}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.authenticatedSignedWrites","authenticatedSignedWrites")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if signed writing to the characteristic value is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.broadcast", "broadcast")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if the broadcast of the characteristic value is permitted using the Server Characteristic Configuration Descriptor.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.indicate","indicate")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if indications of the characteristic value with acknowledgement is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.notify","notify")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if notifications of the characteristic value without acknowledgement is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.read", "read")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if the reading of the characteristic value is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.reliableWrite","reliableWrite")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if reliable writes to the characteristic is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.writableAuxiliaries","writableAuxiliaries")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if reliable writes to the characteristic descriptor is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.write","write")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if the writing to the characteristic with response is permitted.</dd>
 <dt>{{DOMxRef("BluetoothCharacteristicProperties.writeWithoutResponse","writeWithoutResponse")}}{{ReadOnlyInline}}</dt>
 <dd>Returns a <code>boolean</code> that is <code>true</code> if the writing to the characteristic without response is permitted.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example shows how tell if a GATT characteristic supports value change notifications.</p>

<pre class="brush: js notranslate">let device = await navigator.bluetooth.requestDevice({
  filters: [{services: ['heart_rate']}]
});
let gatt = await device.gatt.connect();
let service = await gatt.getPrimaryService('heart_rate');
let characteristic = await service.getCharacteristic('heart_rate_measurement');
if (characteristic.properties.notify) {
  characteristic.addEventListener('characteristicvaluechanged',
      function(event) {
    console.log(`Received heart rate measurement: ${event.target.value}`);
  }
  await characteristic.startNotifications();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Bluetooth','#characteristicproperties-interface','BluetoothCharacteristicProperties')}}</td>
   <td>{{Spec2('Web Bluetooth')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.BluetoothCharacteristicProperties")}}</p>
</div>
